from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, File

Hts_Adaptertrimmer_V0_1_0 = CommandToolBuilder(tool="hts_AdapterTrimmer", base_command=["hts_AdapterTrimmer"], inputs=[ToolInput(tag="in__version_print", input_type=Boolean(optional=True), prefix="-v", doc=InputDocumentation(doc="[ --version ]                      Version print")), ToolInput(tag="in_arg_notes_json", input_type=Boolean(optional=True), prefix="-N", doc=InputDocumentation(doc="[ --notes ] arg                    Notes for the stats JSON")), ToolInput(tag="in_arg_statslog_write", input_type=Boolean(optional=True), prefix="-L", doc=InputDocumentation(doc="[ --stats-file ] arg (=stats.log)  Write to stats file name")), ToolInput(tag="in_arg_append_stats", input_type=Boolean(optional=True), prefix="-A", doc=InputDocumentation(doc="[ --append-stats-file ] arg        Append to stats file name")), ToolInput(tag="in_one", input_type=Boolean(optional=True), prefix="-1", doc=InputDocumentation(doc="[ --read1-input ] arg              Read 1 paired end fastq input <space\nseparated for multiple files>")), ToolInput(tag="in_two", input_type=Boolean(optional=True), prefix="-2", doc=InputDocumentation(doc="[ --read2-input ] arg              Read 2 paired end fastq input <space\nseparated for multiple files>")), ToolInput(tag="in_arg_single_end", input_type=Boolean(optional=True), prefix="-U", doc=InputDocumentation(doc="[ --singleend-input ] arg          Single end read fastq input <space\nseparated for multiple files>")), ToolInput(tag="in_arg_interleaved_fastq", input_type=Boolean(optional=True), prefix="-I", doc=InputDocumentation(doc="[ --interleaved-input ] arg        Interleaved fastq input <space\nseparated for multiple files>")), ToolInput(tag="in_arg_tabdelimited_input", input_type=Boolean(optional=True), prefix="-T", doc=InputDocumentation(doc="[ --tab-input ] arg                Tab-delimited (tab6) input <space\nseparated for multiple files>")), ToolInput(tag="in_forces_overwrite_files", input_type=Boolean(optional=True), prefix="-F", doc=InputDocumentation(doc="[ --force ]                        Forces overwrite of files")), ToolInput(tag="in_output_uncompressed_files", input_type=Boolean(optional=True), prefix="-u", doc=InputDocumentation(doc="[ --uncompressed ]                 Output uncompressed (not gzipped) files")), ToolInput(tag="in_arg_output_fastq", input_type=Boolean(optional=True), prefix="-f", doc=InputDocumentation(doc="[ --fastq-output ] arg             Output to Fastq files <PE AND/OR SE\nfiles>")), ToolInput(tag="in_arg_output_interleaved", input_type=Boolean(optional=True), prefix="-i", doc=InputDocumentation(doc="[ --interleaved-output ] arg       Output to interleaved fastq files\n<INTERLEAVED PE AND/OR SE files>")), ToolInput(tag="in_arg_output_tabdelimited", input_type=File(optional=True), prefix="-t", doc=InputDocumentation(doc="[ --tab-output ] arg               Output to tab-delimited (tab6) file")), ToolInput(tag="in_arg_output_unmapped", input_type=File(optional=True), prefix="-z", doc=InputDocumentation(doc="[ --unmapped-output ] arg          Output to unmapped sam file")), ToolInput(tag="in_arg_number_worker", input_type=Boolean(optional=True), prefix="-p", doc=InputDocumentation(doc="[ --number-of-threads ] arg (=1)   Number of worker threads (min 1, max 8)")), ToolInput(tag="in_arg_kmer_size", input_type=Boolean(optional=True), prefix="-k", doc=InputDocumentation(doc="[ --kmer ] arg (=8)                Kmer size of the lookup table for the\nlonger read (min 5, max 64)")), ToolInput(tag="in_arg_offset_offset", input_type=Boolean(optional=True), prefix="-r", doc=InputDocumentation(doc="[ --kmer-offset ] arg (=1)         Offset of kmers. Offset of 1, would be\nperfect overlapping kmers. An offset of\nkmer would be non-overlapping kmers\nthat are right next to each other. Must\nbe greater than 0.")), ToolInput(tag="in_arg_percent_mismatches", input_type=Boolean(optional=True), prefix="-e", doc=InputDocumentation(doc="[ --max-mismatch-errorDensity ] arg (=0.25)\nMax percent of mismatches allowed in\noverlapped section (min 0.0, max 1.0)")), ToolInput(tag="in_arg_max_number", input_type=Boolean(optional=True), prefix="-x", doc=InputDocumentation(doc="[ --max-mismatch ] arg (=100)      Max number of total mismatches allowed\nin overlapped section (min 0, max\n10000)")), ToolInput(tag="in_arg_check_lengths", input_type=Boolean(optional=True), prefix="-c", doc=InputDocumentation(doc="[ --check-lengths ] arg (=20)      Check lengths of the ends (min 5, max\n10000)")), ToolInput(tag="in_arg_min_overlap", input_type=Boolean(optional=True), prefix="-o", doc=InputDocumentation(doc="[ --min-overlap ] arg (=8)         Min overlap required to merge two reads\n(min 5, max 10000)")), ToolInput(tag="in_trimming_adapter_useconsensus", input_type=Boolean(optional=True), prefix="-X", doc=InputDocumentation(doc="[ --no-fixbases ]                  after trimming adapter, DO NOT use\nconsensus sequence of paired reads,\nonly trims adapter sequence")), ToolInput(tag="in_arg_agatcggaagagcacacgtctgaactccagtcaprimer_sequence", input_type=Boolean(optional=True), prefix="-a", doc=InputDocumentation(doc="[ --adapter-sequence ] arg (=AGATCGGAAGAGCACACGTCTGAACTCCAGTCA)\nPrimer sequence to trim in SE adapter\ntrimming, default is truseq ht primer\nsequence"))], outputs=[ToolOutput(tag="out_arg_output_tabdelimited", output_type=File(optional=True), selector=InputSelector(input_to_select="in_arg_output_tabdelimited", type_hint=File()), doc=OutputDocumentation(doc="[ --tab-output ] arg               Output to tab-delimited (tab6) file")), ToolOutput(tag="out_arg_output_unmapped", output_type=File(optional=True), selector=InputSelector(input_to_select="in_arg_output_unmapped", type_hint=File()), doc=OutputDocumentation(doc="[ --unmapped-output ] arg          Output to unmapped sam file"))], container="quay.io/biocontainers/htstream:1.3.3--h5ca1c16_0", version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Hts_Adaptertrimmer_V0_1_0().translate("wdl")

